import { NestFactory } from '@nestjs/core';
import { MicroserviceOptions, Transport } from '@nestjs/microservices';
import { join } from 'path';
import { AppModule } from './app.module';

async function bootstrap() {
  const app = await NestFactory.createMicroservice<MicroserviceOptions>(
    AppModule,
    {
      transport: Transport.GRPC,
      options: {
        package: ['authentication', 'authorization'],
        protoPath: [
          join(
            __dirname,
            'modules/authentication/adapters/primaries/authentication.proto',
          ),
          join(
            __dirname,
            'modules/authorization/adapters/primaries/authorization.proto',
          ),
        ],
        url: process.env.SERVICE_URL + ':' + process.env.SERVICE_PORT,
        loader: { keepCase: true, enums: String },
      },
    },
  );
  await app.listen();
}
bootstrap();
