import { AmqpConnection } from '@golevelup/nestjs-rabbitmq';
import { Injectable } from '@nestjs/common';
import { IMessageBroker } from '../../domain/interfaces/message-broker';

@Injectable()
export class AuthenticationMessager extends IMessageBroker {
  constructor(private readonly _amqpConnection: AmqpConnection) {
    super('auth');
  }

  publish(routingKey: string, message: string): void {
    this._amqpConnection.publish(this.exchange, routingKey, message);
  }
}
