import { AmqpConnection } from '@golevelup/nestjs-rabbitmq';
import { Test, TestingModule } from '@nestjs/testing';
import { AuthenticationMessager } from '../../adapters/secondaries/authentication.messager';

const mockAmqpConnection = {
  publish: jest.fn().mockImplementation(),
};

describe('AuthenticationMessager', () => {
  let authenticationMessager: AuthenticationMessager;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      imports: [],
      providers: [
        AuthenticationMessager,
        {
          provide: AmqpConnection,
          useValue: mockAmqpConnection,
        },
      ],
    }).compile();

    authenticationMessager = module.get<AuthenticationMessager>(
      AuthenticationMessager,
    );
  });

  it('should be defined', () => {
    expect(authenticationMessager).toBeDefined();
  });

  it('should publish a message', async () => {
    jest.spyOn(mockAmqpConnection, 'publish');
    await authenticationMessager.publish(
      'authentication.create.info',
      'my-test',
    );
    expect(mockAmqpConnection.publish).toHaveBeenCalledTimes(1);
  });
});
