import { HttpModule } from '@nestjs/axios';
import { Module } from '@nestjs/common';
import { CqrsModule } from '@nestjs/cqrs';
import { DatabaseModule } from '../database/database.module';
import { AuthorizationController } from './adapters/primaries/authorization.controller';
import { OpaDecisionMaker } from './adapters/secondaries/opa.decision-maker';
import { DecisionUseCase } from './domain/usecases/decision.usecase';
import { AuthorizationProfile } from './mappers/authorization.profile';

@Module({
  imports: [DatabaseModule, CqrsModule, HttpModule],
  exports: [],
  controllers: [AuthorizationController],
  providers: [OpaDecisionMaker, DecisionUseCase, AuthorizationProfile],
})
export class AuthorizationModule {}
